# AchtDamen_ganz_doof.py
# iterative Ueberarbeitung der Funktion zulaessig

### Schlimmste Version, bei der alle Felder versucht werden, also
### einfachstes GENERATE AND TEST

### ===== Suchraum ==================================================
def erzeugeFeld(maxZahl):
    feld=[]
    for i in range(1,maxZahl+1):
        zeile=[]
        for j in range(1,maxZahl+1):
            feld.append([i, j])
    return feld
    
### ===== Tiefensuche ================================================
# Die Rekursion verwendet hier einfach alle Felder

def tiefensuche(maxZahl=4):
    def suche(alternativen, belegt):
        ##input((alternativen, belegt))
        ##if len(belegt)==maxZahl: print(alternativen,'\n', belegt,'\n')
        if len(belegt)==maxZahl:
            if zulaessig(belegt):
                return belegt
            return False
        if len(alternativen)==0:
            return False
        versuch = suche(feld, [alternativen[0]]+belegt)
        if versuch:
            return versuch
        else:
            return suche(alternativen[1:], belegt)
    feld = erzeugeFeld(maxZahl)
    print('Feld',feld,'\n')
    return suche(erzeugeFeld(maxZahl), [])

### ===== zulaessig ================================================
# Es wird nacheinander geprueft, ob sich Zeilen- oder Spaltenindizes
# und Diagonalendifferenzen wiederholen.
# uebergeben wird die liste der Belegungen
def zulaessig(belegt):
    for i in range(len(belegt)-1):
        for j in range(i+1, len(belegt)):
            x1,y1=belegt[i]
            x2,y2=belegt[j]
            ##input(((x1,y1),(x2,y2)))
            if x1==x2: return False          # gleiche Zeile
            if y1==y2: return False          # gleiche Spalte
            if x1-y1 == x2-y2: return False  # gleiche Diagonale ru
            if x1+y1 == x2+y2: return False  # gleiche Diagonale lu
    return True

### ===== Darstellung ============================================
def zeigeFeld(damen):
    damen.reverse()
    print(damen)
    for i in range(len(damen)):
        for j in range(len(damen)):
            if damen[i][1]-1==j: print('D', end=' ')
            else: print('*', end=' ')
        print()        

### ==============================================================
zeigeFeld(tiefensuche(4))
